/******************************************/ 
/* Carbon-compatible section of OroborOSX */
/* (c) Adrian Umpleby Sept 2001           */
/*                                        */
/* Original oroborus window manager code  */
/* (c) Ken Lynch Jan 2001                 */
/*                                        */
/* This file started life as main.c from  */
/* Apple's prototype Carbon application   */
/*                                        */
/* Distributed under the GPL              */ 
/* See LICENSE for more details           */ 
/******************************************/ 
 
/* main.c */

#include <stdlib.h> 
#include <stdio.h> 

#include <Carbon/Carbon.h>

#include "main.h"
#include "common.h"

typedef struct{
    char len;
    char thestr[256];
} pstr_t;

WindowRef	lastFrontWin=NULL, noFocusWin=NULL, aboutWin=NULL;
WindowRef	waiting1Win=NULL, waiting2Win=NULL, passwordWin=NULL;
char		*Display_Name=NULL, *xpidstr=NULL, *xverstr=NULL, *gThemeDir=NULL;
char		*nextItem=NULL, *aboutThemeItem=NULL;
GDHandle	gMainScreen;
Rect		gMainRect;
char		realPath[512], myPath[512], randomID[20], lastsub[255];
char		*lastsub15, *lastsub14, *lastsub13, *lastsub12, *lastsub11;
char		*lastsub10, *lastsub9, *lastsub8, *lastsub7, *lastsub6;
char		*lastsub5, *lastsub4, *lastsub3, *lastsub2, *lastsub1;
// No longer needed, since these items have now been replaced by items in "Launch Menu Items" folder
//int		launch_count_xterm=1, launch_count_xedit=1, launch_count_xcalc=1;
//int		launch_count_xclock=1, launch_count_xbiff=1, launch_count_xeyes=1;
int 		realPathLen, myPathLen, gQuitFlag=0, reReadOnNextFront=0;
int		themeItemsCount=8, launchItemsCount=17;
int		gX11InFront=0, on_cmd_line=0, showingAboutWin=0, showingNoFocusWin=0;
int		gHiding_Iconbars=1, gInterleaving_Windows=0, gMenubarSpace=0, gUseShapedTheme=0;
int		noIdleMax=3, idleCount=0, cycleOff=0;
int		mouse_mode=MOUSE_NORMAL, real_x, real_y, lastrl_x=0, lastrl_y=0;
int		iconbarpos=ICONBARPOS_TOPLEFT, iconbar_screen=0, shrinking_iconbars=1;
int		diffscrn_x=0, diffscrn_y=0, gInvisible=0, gX11MouseStuck=0;
int		lastchk_x=0, lastchk_y=0, lastchk_cnt=0, lastx11_x=0, lastx11_y=0;
long		lastBackTicks, lastIconbarOutTicks=0, iconbar_WaitTicks=100, lastOKTicks=0;
long		lastMovedTicks=0, lastMovedTen=0, lastCompareTicks=0, gGotMenuClick=0;
// guess I should really make sure the Launch menu is not too long...
int		launch_counter[250];	// should be enough items, though   :-)
Boolean		forceOOSXInFront=FALSE, xdarwin_is_stopped=FALSE;
ProcessSerialNumber	xPSN, myPSN;

void Initialize(void);
void EventLoop(void);
void MakeMenu(void);
void DoEvent(EventRecord *event);
void DoIdle(int trackMouse);
void DoMenuCommand(long menuResult, short menuID, short menuItem);
int LaunchMenuItem(char *itemname, int hasext, int hasnl);
void DoAboutBox(void);
void ShowOroborOSXHelp(void);
void DrawWindow(WindowRef window);
int CheckForX(void);
void LaunchX_GetPID(int launchit);
void Bring_To_Front(int quick);
void Bring_X_To_Front(int quick);
void Bring_OOSX_To_Front(void);
static OSErr QuitAppleEventHandler(const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon);
static OSErr ODOCAppleEventHandler(const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon);
static OSErr RAPPAppleEventHandler(const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon);
void Stop_XDarwin();
void Restart_XDarwin();
void Create_Launch_Menu();
void Setup_Themes_Menu(int which);
void Create_Themes_Menu(int setThemeDir);
void Launch_Startup_Items();
void subtrace();

WindowRef MakeWindow(int windowtype)
{
    WindowRef	myWindow;
    Handle	menuBar;
    MenuRef	menu;
    long	response;
    OSErr	err;
    OSStatus	myStat;
    IBNibRef	theNIBRef;
    Rect	winrct;
//    pstr_t	ptitle;
    
    sprintf(lastsub,"TRACE3: MakeWindow (type: %d)\n",windowtype);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: MakeWindow (type: %d)\n",windowtype);
#endif

    if(windowtype==x11Wintype || windowtype==noFocusWintype) {
/* Only set size for the x11 windows and the 'no active window' window */    
        winrct.left=1;
        winrct.right=2;
        winrct.top=21;
        winrct.bottom=22;
    }
    
    myStat = CreateNibReference(CFSTR("window"),&theNIBRef);
    
    switch(windowtype)
    {
/* put up the information window */
    case waiting1Wintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("Waiting1"),&myWindow);
        break;
    case waiting2Wintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("Waiting2"),&myWindow);
        break;
    case waiting3Wintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("Waiting3"),&myWindow);
        break;
/* special window for when all X11 windows are iconbars */    
    case noFocusWintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("NoFocusWin"),&myWindow);
        break;
/* put up the about window */
    case aboutWintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("About"),&myWindow);
        break;
/* put up the interleaving dialog */
    case passwordWintype:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("Password"),&myWindow);
        break;
/* make a 'dummy' window, so that it appears in dock icon's window list */
    default:
        myStat = CreateWindowFromNib(theNIBRef,CFSTR("Window"),&myWindow);
        HideWindow(noFocusWin);
        showingNoFocusWin=0;
        break;
    }
    
    if(myWindow==NULL) return NULL;
    
/* Only set title if it's an x11 window */    
    if(windowtype==x11Wintype) {
        myStat=SetWindowBounds(myWindow,kWindowContentRgn,&winrct);
    } else if(windowtype==noFocusWintype)
        myStat=SetWindowBounds(myWindow,kWindowContentRgn,&winrct);
    
    ShowWindow(myWindow);
    
    DisposeNibReference(theNIBRef);

/* make sure it is not on the screen (if it's one of the x11 windows etc.) */    
    if(windowtype==x11Wintype || windowtype==noFocusWintype)
        MoveWindow(myWindow,-5000,-5000,false);
    
    return myWindow;
}

int main2(int argc, char *argv[])
{
        int retval, i, dummy;

        waiting1Win=MakeWindow(waiting1Wintype);

// Check to see if XDarwin is already running
        printf("%s info: checking for XDarwin\n",PROGNAME);
        if(CheckForX()==0) {
// Try to launch it if not
            waiting2Win=MakeWindow(waiting2Wintype);
            if(waiting1Win) DisposeWindow(waiting1Win);
            waiting1Win=waiting2Win;
            waiting2Win=NULL;
            LaunchX_GetPID(1);
            retval=-100;
            if(gQuitFlag==0) {
                i=0;
                while(retval!=0 && i<10) {
// See if the window manager can find the display yet
                    waiting2Win=MakeWindow(waiting3Wintype);
                    if(waiting1Win) DisposeWindow(waiting1Win);
                    waiting1Win=waiting2Win;
                    waiting2Win=NULL;
                    Restart_XDarwin();
                    retval=orob_main(argc,argv);
                    if(retval!=0) {
                        printf("%s info: Waiting for XDarwin to be ready... %d\n",PROGNAME,retval);
                        dummy=sleep(2);
                        //system("/bin/sleep 2");
                        i++;
                    }
                }
            }
            if(retval==0) {
                printf("%s info: XDarwin is ready...\n",PROGNAME);
            } else {	/* Should have an alert here... */
                fprintf(stderr,"%s: XDarwin has not initialised correctly. Aborting.",PROGNAME);
            }
        } else {
// Just get the PID for XDarwin
            LaunchX_GetPID(0);
            waiting2Win=MakeWindow(waiting3Wintype);
            if(waiting1Win) DisposeWindow(waiting1Win);
            waiting1Win=waiting2Win;
            waiting2Win=NULL;
            Restart_XDarwin();
            retval=orob_main(argc,argv);
            if(retval!=0) {
                dummy=sleep(2);
                if(CheckForX()==0) {
                    printf("%s warning: lost XDarwin -will try launching again...\n",PROGNAME);
                    retval=10203;
                }
            }
        }
        if(waiting1Win) DisposeWindow(waiting1Win);
        if( retval==0 ) {
            EventLoop();
        } else	/* Should have an alert here... */
            fprintf(stderr,"%s: Got an error from orob_main: %d\n",PROGNAME,retval);

	return retval;
}

int main(int argc, char *argv[])
{
    int retval;
    
    sprintf(lastsub,"TRACE1: main (argc: %d)\n",argc);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: main (argc: %d)\n",argc);
#endif

    Initialize();

// Grab the Menu bar from the nib package
    MakeMenu();
        
// Create the special window for the 'all iconbars' case, and the 'no clients' case
    noFocusWin=MakeWindow(noFocusWintype);

    // try to run...
    retval=main2(argc,argv);
    
    // try again if it found XDarwin was there to start with, then vanished...
    if(retval==10203)
        retval=main2(argc,argv);
        
    return 0;
}

int SetMyPath()
{
    CFURLRef	myURL;
    CFBundleRef mainBundle;
    int		i;
    
    sprintf(lastsub,"TRACE2: SetMyPath\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: SetMyPath\n");
#endif

// Get the main bundle for the app, and find the path
    realPathLen=512;
    mainBundle = CFBundleGetMainBundle();
    myURL=CFBundleCopyBundleURL(mainBundle);
    CFURLGetFileSystemRepresentation(myURL,TRUE,realPath,realPathLen);
    
// Now search for single quotes, replacing them with '\'' to create the path used for
// starting scripts. The real path is also kept so that the config file can be read.
    realPathLen=strlen(realPath);
    myPathLen=0;
    for(i=0;i<=realPathLen;i++) {
        myPath[myPathLen]=realPath[i];
        myPathLen++;
        if(realPath[i]==39) {
            if(myPathLen>508) {
                fprintf(stderr,"%s: Path name too long! %s\n",PROGNAME,myPath);
                return -1; }
            myPath[myPathLen]=92;
            myPathLen++;
            myPath[myPathLen]=39;
            myPathLen++;
            myPath[myPathLen]=39;
            myPathLen++;
        }
    }
    printf("%s info: myPathLen,realPathLen: %d,%d\n",PROGNAME,myPathLen,realPathLen);
    printf("%s info: myPath: %s\n",PROGNAME,myPath);
    myPath[myPathLen]=0;
    myPathLen=strlen(myPath);
    i=chdir(realPath);
    system("echo -n 'chdir: ';pwd");
    return i;
}

void Initialize()	/* Initialize some things */
{
    OSErr	err;

    sprintf(lastsub,"TRACE1: Initialize\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Initialize\n");
#endif

// Cursor manager    
    InitCursor();
    
// Make sure path to OroborOSX is set up
    SetMyPath();

// Get the PSN for OroborOSX
    err = GetCurrentProcess(&myPSN);

// Install the quit AppleEvent handler
    err = AEInstallEventHandler( kCoreEventClass, kAEQuitApplication, NewAEEventHandlerUPP((AEEventHandlerProcPtr)QuitAppleEventHandler), 0, false );
    if (err != noErr)
        ExitToShell();

// Install the rapp AppleEvent handler
    err = AEInstallEventHandler( kCoreEventClass, kAEReopenApplication, NewAEEventHandlerUPP((AEEventHandlerProcPtr)RAPPAppleEventHandler), 0, false );
    if (err != noErr)
        ExitToShell();

// Install the odoc AppleEvent handler
    err = AEInstallEventHandler( kCoreEventClass, kAEOpenDocuments, NewAEEventHandlerUPP((AEEventHandlerProcPtr)ODOCAppleEventHandler), 0, false );
    if (err != noErr)
        ExitToShell();
        
// Make a unique (probably!) ID for this process to create temporary files
    sprintf(randomID,"%#lx",random());
    
    gMainScreen=GetMainDevice();
    if(gMainScreen==NULL) {
        printf("%s warning: Got NULL for GetMainDevice?!\n",PROGNAME);
        return;
    } else if(*gMainScreen==NULL) {
        printf("%s warning: Got NULL pointer for GetMainDevice?!\n",PROGNAME);
        return;
    }
    gMainRect=(*gMainScreen)->gdRect;
    printf("%s info: Found main screen: %#lx  (%d,%d,%d,%d)\n",PROGNAME,gMainScreen,gMainRect.left,gMainRect.top,gMainRect.right,gMainRect.bottom);
}

static OSErr QuitAppleEventHandler( const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon )
{
    sprintf(lastsub,"TRACE1: QuitAppleEventHandler\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: QuitAppleEventHandler\n");
#endif

    quit();
    gQuitFlag =  1;
    
    return noErr;
}

static OSErr RAPPAppleEventHandler( const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon )
{
    sprintf(lastsub,"TRACE1: RAPPAppleEventHandler\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: RAPPAppleEventHandler\n");
#endif

#ifdef DEBUG
    printf("Got a 'rapp' AppleEvent\n");
#endif
    if(gInvisible!=0) {
        gInvisible=0;
        map_all_clients();
    }
    raise_all_clients();
    
    return noErr;
}

static OSErr ODOCAppleEventHandler( const AppleEvent *appleEvt, AppleEvent* reply, UInt32 refcon )
{
    OSType	HLEclass, HLEmsgID;
    OSErr	myErr;
    long	i, ni;
    int		namelen;
    DescType	typeCode;
    Size	dataSize;
    AEDescList	myDesc, newDesc;
    AEKeyword	theAEKeyword;
    Boolean	changed, dummy;
    FSSpec	mySpec;
    AliasHandle	myAlias;
    pstr_t	*pStr;
    char	*cStr;
    
    sprintf(lastsub,"TRACE1: ODOCAppleEventHandler\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: ODOCAppleEventHandler\n");
#endif

    HLEmsgID = appleEvt->descriptorType;
    HLEclass = reply->descriptorType;
    
    myErr=AECountItems(appleEvt,&ni);
    
    printf("  Number of initial items: %d\n",ni);
    
    if(ni>0) {
        myErr=AESizeOfNthItem(appleEvt, 1, &typeCode, &dataSize);
        printf("  typeCode,dataSize: %d,%d\n",typeCode,dataSize);
        myErr=AEGetNthDesc(appleEvt,1,typeCode,&theAEKeyword,&myDesc);
        HLEclass=(OSType) theAEKeyword;
        HLEmsgID=myDesc.descriptorType;
        printf("  HLEclass,HLEmsgID: %d,%d\n",HLEclass,HLEmsgID);
        myErr=AECountItems(&myDesc,&ni);
        printf("  Number of actual items: %d\n",ni);
        
        for(i=1;i<=ni;i++) {
            myErr=AESizeOfNthItem(&myDesc,i,&typeCode,&dataSize);
            printf("  item %d   typeCode,dataSize: %d,%d\n",i,typeCode,dataSize);
            myErr=AEGetNthDesc(&myDesc,i,typeCode,&theAEKeyword,&newDesc);
            myAlias=(AliasHandle) newDesc.dataHandle;
            printf("  item %d   myAlias: %#lx\n",i,myAlias);
            myErr=ResolveAlias(NULL,myAlias,&mySpec,&changed);
            if(myErr==noErr) {
// Use the horrible hack to get C string out of a Pascal string
// -there's probably a macro somewhere to do this 'legally'...
                pStr=&(mySpec.name);
                namelen=pStr->len;
                cStr=&(pStr->thestr);
                cStr[namelen]=0;
                printf("  item %d  name: %s\n",i,cStr);
// Now look for that item in the Launch menu, and run the associated script
                myErr=LaunchMenuItem(cStr,1,0);
                if(myErr!=0)
                    printf("%s warning: could not launch item %s -got error %d\n",PROGNAME,cStr,myErr);
            } else
                printf("  item %d  got an error: %d\n",i,myErr);
        }
    }
    
    return noErr;
}

int CheckForX()
{
    ProcessInfoRec	procInfo;
    ProcessSerialNumber aPSN;
    short		myErr;
    pstr_t		procName;
    
    sprintf(lastsub,"TRACE1: CheckForX\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: CheckForX\n");
#endif

    aPSN.highLongOfPSN=0;
    aPSN.lowLongOfPSN=0;

    myErr=noErr;

// Go through list of applications, looking for XDarwin
    while(myErr==noErr) {
    
        myErr=GetNextProcess(&aPSN);
    
        if(myErr==noErr) {
            procInfo.processName=(char *) &procName;
            procInfo.processAppSpec=NULL;
            myErr=GetProcessInformation(&aPSN,&procInfo);
        } else if(myErr==-600 || myErr==-50)
            myErr=-1000;
        
        if(myErr==-50)
            myErr=noErr;
        else if(myErr==noErr) {
            if(strncmp(procName.thestr,XDARWIN_NAME,XDARWIN_NAMELEN)==0) {
// Found XDarwin!
                xPSN=aPSN;
                return 1;
            }
        }
    }
    
    return 0;
}

void LaunchX_GetPID(int launchit)
{
    char *script=NULL, *lvalue=NULL;
    char buf[20];
    int i, dummy;
    FILE *file;

    sprintf(lastsub,"TRACE1: LaunchX_GetPID (launchit: %d)\n",launchit);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: LaunchX_GetPID (launchit: %d)\n",launchit);
#endif

#ifdef DEBUG    
    printf("About to malloc script: 40\n");
#endif
    script=malloc(40);
#ifdef DEBUG    
    printf("script: %#lx\n",(long) script);
#endif

    diffscrn_x=0;
    diffscrn_y=GetMBarHeight()-1;
    printf("%s info: Started with screen offset: %d,%d\n",PROGNAME,diffscrn_x,diffscrn_y);
    
    if(script==NULL)
    {
        if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in LaunchX_GetPID.\n", PROGNAME);
            exit(1);
        } else {
            fprintf(stderr, "%s: Memory allocation failed in LaunchX_GetPID.\n", PROGNAME);
            gQuitFlag=-30;
            return;
        }
    }
    
    if(launchit!=0) {
        sprintf(script,"Contents/Scripts/startx");
        printf("%s info: X11 startup script: %s\n",PROGNAME,script);
  
// run script to start up X11...
        system(script);
//    system("PATH=.:/usr/bin:/bin:/usr/X11R6/bin:/usr/local/bin:~/bin;startx -- -rootless &");

// Not very Mac-ish way to wait for something...!
        i=0;
        while(CheckForX()==0 && i<15) {
            printf("%s is waiting for XDarwin to start...\n",PROGNAME);
            dummy=sleep(2);
            //system("/bin/sleep 2");
            i++;
        }
    
        if(i==15) {
            free(script);
            fprintf(stderr,"%s: failed to start XDarwin\n",PROGNAME);
            gQuitFlag=-40;
            return;
        }
// wait a couple of seconds to make sure everything has calmed down...
        dummy=sleep(2);
        //system("/bin/sleep 2");
    }

// use the random string as part of the PID filename
    sprintf(script,"Contents/Scripts/GetXpid %s",randomID);
    printf("%s info: Getting XDarwin info: %s\n",PROGNAME,script);
// run script which finds the PID and version of XDarwin...
    system(script);
        
// Now open the file (/tmp/XDarwin-pid.'$randomID')
    sprintf(script,"/tmp/XDarwin-pid.%s",randomID);
    if((file=fopen(script, "r"))) 
    {
// and extract the PID from it
        if(fgets(buf, sizeof buf, file)) 
        { 
            lvalue=strtok(buf, "\n"); 
            if(lvalue)
                xpidstr=strdup(lvalue);
            else
                xpidstr=strdup(buf);
            printf("%s info: Got XDarwin PID: %s\n",PROGNAME,xpidstr);
        } 
// and extract the version from it
        if(fgets(buf, sizeof buf, file)) 
        { 
            lvalue=strtok(buf, "\n"); 
            if(lvalue)
                xverstr=strdup(lvalue);
            else
                xverstr=strdup(buf);
            printf("%s info: Got XDarwin version: %s\n",PROGNAME,xverstr);
        } else {
            printf("%s warning: Failed to get version for XDarwin...\n",PROGNAME);
            xverstr=strdup("?????");
        }
        fclose(file);
// and get rid of the file
        sprintf(script,"/bin/rm -f /tmp/XDarwin-pid.%s",randomID);
        printf("%s info: Removing file: %s\n",PROGNAME,script);
        system(script);
// now check which version we got and change various things appropriately
        gUseShapedTheme=1;
        if(!strncmp(xverstr,"*****",5))
            gUseShapedTheme=1;
        else if(!strncmp(xverstr,"1.0a3",5))
            gUseShapedTheme=0;
        else if(!strncmp(xverstr,"1.0a2",5))
            gUseShapedTheme=0;
        else if(!strncmp(xverstr,"1.0a1",5)) {
            gUseShapedTheme=0;
            gMenubarSpace=1;
            diffscrn_y=0;
            printf("%s info: Resetting screen offset: 0,0\n",PROGNAME);
        }
        Setup_Themes_Menu(0);
        setenv("XDARWIN_VERSION",xverstr,1);
    } else
        printf("%s warning: pid file not found (%s)\n",PROGNAME,script);

// wait a second to make sure everything has calmed down...
    dummy=sleep(1);
    //system("/bin/sleep 1");
    
#ifdef DEBUG
    printf("About to free script in LaunchX_GetPID...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void Restart_XDarwin()
{
    char	script[25];
    
#ifndef STOPSTART
    return;
#endif
    if(!xpidstr) return;
    
    printf("%s is CHECKING XDARWIN status: %d\n",PROGNAME,xdarwin_is_stopped==FALSE?0:1);
    if(xdarwin_is_stopped) {
        sprintf(script,"kill -CONT %s",xpidstr);
        printf("%s is CONTINUING XDARWIN: %s\n",PROGNAME,script);
        system(script);
        xdarwin_is_stopped=FALSE;
    }
}

void Stop_XDarwin()
{
    char	script[25];
    
#ifndef STOPSTART
    return;
#endif
    if(!xpidstr) return;
    
    printf("%s is CHECKING XDARWIN: %d\n",PROGNAME,xdarwin_is_stopped==FALSE?0:1);
    if(!xdarwin_is_stopped) {
        sprintf(script,"kill -STOP %s",xpidstr);
        printf("%s is STOPPING XDARWIN: %s\n",PROGNAME,script);
        system(script);
        xdarwin_is_stopped=TRUE;
    }
}

void Bring_To_Front(int quick)	/* when an X11 window is clicked, bring everything in front */
{
    OSErr		myErr;
    Boolean		same;
    ProcessSerialNumber	frontPSN;
    
    sprintf(lastsub,"TRACE2: Bring_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_To_Front\n");
#endif

    myErr=SetFrontProcess(&myPSN);
    
    same=FALSE;
    while(!same) {
        myErr=GetFrontProcess(&frontPSN);
        if(myErr==noErr)
            myErr=SameProcess(&frontPSN,&myPSN,&same);
        if(myErr!=noErr) {
#ifdef SHOW_WEIRD
            printf("%s warning: Got an error trying to check if OOSX is in front?!\n",PROGNAME);
#endif
            same=TRUE;
            forceOOSXInFront=TRUE;
        }
    }
    
    if(passwordWin!=NULL) {
        ShowWindow(passwordWin);
        SelectWindow(passwordWin);
        return;
    }
    
    myErr=SetFrontProcess(&xPSN);

    same=FALSE;
    while(!same) {
        myErr=GetFrontProcess(&frontPSN);
        if(myErr==noErr)
            myErr=SameProcess(&frontPSN,&xPSN,&same);
        if(myErr!=noErr) {
#ifdef SHOW_WEIRD
            printf("%s warning: Got an error trying to check if XDarwin is in front?!\n",PROGNAME);
#endif
            same=TRUE;
        }
    }
    
#ifdef DEBUG
    printf("XDarwin has been forced to front\n");
#endif

/*    if(stopx!=0) {
        Stop_XDarwin();
        dummy=sleep(1);
        //system("/bin/sleep 1");
        Restart_XDarwin();
    }*/

    if(gX11InFront==0 && quick==0) {
        gX11InFront=1;
        come_to_front();
    }
// Also set a flag so that OroborOSX will be forced in front briefly (in DoIdle),
// so that its menubar will be visible...
//    forceOOSXInFront=TRUE;
}

void Bring_OOSX_To_Front()	/* bring OroborOSX in front */
{
    OSErr		myErr;
    
    sprintf(lastsub,"TRACE2: Bring_OOSX_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_OOSX_To_Front\n");
#endif

    myErr=SetFrontProcess(&myPSN);
//    myErr=SetFrontProcess(&xPSN);
//    gX11InFront=1;
}

void Bring_X_To_Front(int quick)	/* bring XDarwin in front */
{
    OSErr		myErr;
    
    sprintf(lastsub,"TRACE2: Bring_X_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_X_To_Front\n");
#endif

    if(passwordWin!=NULL) {
        myErr=SetFrontProcess(&myPSN);
        ShowWindow(passwordWin);
        SelectWindow(passwordWin);
        return;
    }

//    myErr=SetFrontProcess(&myPSN);
    myErr=SetFrontProcess(&xPSN);
#ifdef DEBUG
    printf("XDarwin has been forced to front\n");
#endif
    if(gX11InFront==0 && quick==0) {
        gX11InFront=1;
        come_to_front();
    }
}

void EventLoop()
{
    int		dummy;
    Boolean	gotEvent;
    EventRecord	event;
    char	script[90];
        
    sprintf(lastsub,"TRACE1: EventLoop\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: EventLoop\n");
#endif

    gQuitFlag = 0;

// Make sure we're all in front once started...
    Restart_XDarwin();
    Bring_To_Front(0);
    Stop_XDarwin();

    idleCount=0;
    noIdleMax=3;
// Leave longer gaps between background mouse tracking if tracers are on
#ifdef SHOW_TRACE1
    noIdleMax=10;
#endif
#ifdef SHOW_TRACE2
    noIdleMax=20;
#endif
#ifdef SHOW_TRACE3
    noIdleMax=50;
#endif

// xinerama should have been checked by now, so add screens to Options menu
    Setup_Options_Menu(itemScreenListStart+iconbar_screen);

// and launch the items in the StartupItems file
    Launch_Startup_Items();

    do
    {
        if(TickCount()>lastOKTicks+600) {
            lastOKTicks=TickCount();
// Write to console for the moment, to try and keep track of when it hangs
//            sprintf(script,"echo -n 'reRead: %d    ';date",reReadOnNextFront);
#ifdef SHOW_10S_LOG
            sprintf(script,"echo -n '%s still OK on  ';date;/usr/bin/touch /var/tmp/oroborosx.check",PROGNAME);
#else
            sprintf(script,"/usr/bin/touch /var/tmp/oroborosx.check");
#endif
            system(script);
// Do we still need to recheck the Launch Menu Items folder...?
/*            if(gX11InFront==1) {
                if(reReadOnNextFront<0) {
                    Create_Launch_Menu();
                    reReadOnNextFront=-reReadOnNextFront;
                }
            } else if(reReadOnNextFront>0) {
                Create_Launch_Menu();
                reReadOnNextFront--;
            }
*/
            check_osx_windows_bounds();
        }

        
    sprintf(lastsub,"TRACE1: Calling WaitNextEvent in Eventloop\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Calling WaitNextEvent in Eventloop\n");
#endif

        Stop_XDarwin();
        gotEvent = WaitNextEvent(everyEvent,&event,3,nil);
        Restart_XDarwin();

    sprintf(lastsub,"TRACE1: Back from WaitNextEvent in Eventloop\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Back from WaitNextEvent in Eventloop\n");
#endif

        /*
        if(gX11InFront!=0 || mouse_mode!=MOUSE_NORMAL) {
            if( moving==2 )
                gotEvent = WaitNextEvent(everyEvent,&event,2,nil);
            else
                gotEvent = WaitNextEvent(everyEvent,&event,6,nil);
        } else if( moving==2 )
            gotEvent = WaitNextEvent(everyEvent,&event,3,nil);
        else
            gotEvent = WaitNextEvent(everyEvent,&event,8,nil);
        */
        if(gQuitFlag==0) {
            if (event.what!=0)
                DoEvent(&event);
            else if(idleCount==noIdleMax) {
                DoIdle(1);
                idleCount=0;
            } else {
                DoIdle(0);
                idleCount++;
            }
        }
        
    } while (gQuitFlag==0);
    
    dummy=sleep(1);
    //system("/bin/sleep 1");
    ExitToShell();					
}

void MakeX11Window(OSXWinInfo *winfo, char *title, char *class)
{
    WindowRef	winref;
    
    sprintf(lastsub,"TRACE2: MakeX11Window (winfo,title,class: %#lx,  %s  %s)\n",winfo,title,class);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: MakeX11Window (winfo,title,class: %#lx,  %s  %s)\n",winfo,title,class);
#endif

    winref=MakeWindow(x11Wintype);
    
    if(winref==0) {
        printf("%s warning: Failed to create X11 window: %s  (%#lx)\n",PROGNAME,title,winref);
        return;
    }
    
    CheckOSXWinTitle(winfo,title,class);
    
#ifdef DEBUG
    printf("Created X11 window: %s  (%#lx)\n",title,winref);
#endif

    winfo->winref=(long) winref;
}

void Check_OSX_Window_Bounds(OSXWinInfo *winfo) {
    long	winref=0;
    
    if(winfo!=NULL);
        winref=winfo->winref;
    if(winref==0) return;

// don't bother checking bounds -just make sure it's offscreen...
    MoveWindow((WindowRef) winref,-5000,-5000,false);
}

void ReorderOSXWin(OSXWinInfo *winfo)	/* Put a window at the bottom of the dock icon window list */
{
    long	winref=0;
    
    if(winfo!=NULL);
        winref=winfo->winref;
    
    sprintf(lastsub,"TRACE2: ReorderOSXWindow (winref: %d)\n",winref);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: ReorderOSXWindow (winref: %d)\n",winref);
#endif

    if(winref==0) return;

// this is enough to put the window at the bottom of the list
    HideWindow((WindowRef) winref);
    ShowWindow((WindowRef) winref);
    
// just to make sure it's offscreen...
    MoveWindow((WindowRef) winref,-5000,-5000,false);
}

void CheckOSXWinTitle(OSXWinInfo *winfo, char *title, char *class)  // Check title in dock icon window list
{
    pstr_t	ptitle;
    char	*osxtitle;
    long	winref=0;
    
    if(winfo!=NULL);
        winref=winfo->winref;
    
    sprintf(lastsub,"TRACE3: CheckOSXWinTitle (winref: %d)\n",winref);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: CheckOSXWinTitle (winref: %d)\n",winref);
#endif

    if(winref==0) return;
    
    osxtitle=&ptitle.thestr;
    if(title==NULL && class==NULL)
      sprintf(osxtitle,"?:  Untitled");
    else if(title==NULL)
      sprintf(osxtitle,"%s:  Untitled",class);
    else
      sprintf(osxtitle,"%s:  %s",class,title);
      
    ptitle.len=strlen(osxtitle);
//    strncpy((char *) &ptitle.thestr,title,ptitle.len);
    
    MoveWindow((WindowRef) winref,-5000,-5000,false);
    SetWTitle((WindowRef) winref, (char *) &ptitle);
}

void DestroyOSXWindow(OSXWinInfo *winfo)
{
    long	winref=0;
    
    if(winfo!=NULL);
        winref=winfo->winref;
    
    sprintf(lastsub,"TRACE3: DestroyOSXWindow (winref: %d)\n",winref);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: DestroyOSXWindow (winref: %d)\n",winref);
#endif
    
    if(winref==0) return;
    
// This disposes of the OroborOSX window associated with the X11 window
    DisposeWindow((WindowRef) winref);
}

/*
 * X11 window has moved or changed size -update info
 * input...
 * winfo: pointer to OSWinInfo structure, which is filled in with the relevant information
 * x,y: X11 co-ords of top-left of frame
 * w,h: width and height of frame
 * wox,woy: top-left widget co-ords relative to top-left of frame
 * wendox,wendoy: bottom-right widget co-ords relative to top-left of frame
 */
void SetOSXWinPos(OSXWinInfo *winfo,int x, int y, int w, int h, int wox, int woy, int wendox, int wendoy) 
{
    long	winref=0;
    
    if(winfo!=NULL)
        winref=winfo->winref;

    sprintf(lastsub,"TRACE2: HideOSXWin (winref: %d)\n",winref);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: HideOSXWin (winref: %d)\n",winref);
#endif

    if(winref==0) return;
        
    winfo->x=x;
    winfo->y=y;
    winfo->width=w;
    winfo->height=h;
    
    winfo->widgets_x=x+wox;
    winfo->widgets_y=y+woy;
    winfo->widgets_w=x+wendox;
    winfo->widgets_h=y+wendoy;
}

void HideOSXWin(OSXWinInfo *winfo)	// called when an X11 window is minimised
{
    long	winref=0;
    
    if(winfo!=NULL);
        winref=winfo->winref;
    
    sprintf(lastsub,"TRACE2: HideOSXWin (winref: %d)\n",winref);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: HideOSXWin (winref: %d)\n",winref);
#endif

    if(winref==0) return;
    
// note: don't actually use this since it removes it from the window list in the dock icon
//    HideWindow((WindowRef) winref);

// But this hook might be useful at some point, so that main can do something when a window is minimised
}

void FocusOSXWin(OSXWinInfo *winfo)
{
    long	winref=0;
    
    sprintf(lastsub,"TRACE2: FocusOSXWin (winfo: %#lx)\n",winfo);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: FocusOSXWin (winfo,winref: %#lx,%d)\n",winfo,winref);
#endif

    if(winfo==NULL) {
#ifdef SHOW_TRACE2
        printf("  FocusOSXWin got NULL\n");
#endif
        if(passwordWin!=NULL) {
            Bring_OOSX_To_Front();
            ShowWindow(passwordWin);
            SelectWindow(passwordWin);
            HideWindow(noFocusWin);
            lastFrontWin=passwordWin;
            showingNoFocusWin=1;
            Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
        } else if(showingAboutWin) {
            ShowWindow(aboutWin);
            SelectWindow(aboutWin);
            HideWindow(noFocusWin);
            lastFrontWin=aboutWin;
            showingNoFocusWin=1;
#ifdef DEBUG
            printf("Selected window: %#lx\n",aboutWin);
#endif
            Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
        } else {
            ShowWindow(noFocusWin);
            showingNoFocusWin=1;
            MoveWindow(noFocusWin,-5000,-5000,false);
            SelectWindow(noFocusWin);
#ifdef DEBUG
            printf("Selected window: %#lx\n",noFocusWin);
#endif
            lastFrontWin=noFocusWin;
            Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
        }
        return;
    }
    
    HideWindow(noFocusWin);
    showingNoFocusWin=0;
    
    winref=winfo->winref;
#ifdef SHOW_TRACE2
    printf("  FocusOSXWin (winfo,winref: %#lx,%d)\n",winfo,winref);
#endif

    ShowWindow((WindowRef) winref);
    SelectWindow((WindowRef) winref);
    lastFrontWin=(WindowRef) winref;
#ifdef DEBUG
    printf("Selected window: %#lx\n",winref);
#endif
}

void will_hide_all_iconbars()
{
    sprintf(lastsub,"TRACE2: will_hide_all_iconbars (lastIconbarOutTicks: %d)\n",lastIconbarOutTicks);
    subtrace();
    lastIconbarOutTicks=TickCount();
#ifdef SHOW_TRACE2
    printf("TRACE2: will_hide_all_iconbars (lastIconbarOutTicks: %d)\n",lastIconbarOutTicks);
#endif
}

/*
 * Rather 'non-Macish' way to get a list of files in the Themes folder,
 * and then use it to create the user items for the Themes submenu
 */
void Create_Themes_Menu(int setThemeDir)
{
    MenuRef	menu;
    int		i, buflen, jjj;
    char	*script=NULL, *buf=NULL;
    FILE	*file;
    OSStatus	stat;
    pstr_t	*pStr;
    char	*cStr;
    Str255	itemStr;

//    menu = GetMenuHandle( menuThemes );
    stat = GetMenuItemHierarchicalMenu( GetMenuHandle(menuOptions), itemThemeSubmenu, &menu );
    
    sprintf(lastsub,"TRACE1: Create_Themes_Menu (set, menu: %d, %#lx)\n",setThemeDir,menu);
    subtrace();
//#ifdef SHOW_TRACE1    
    printf("TRACE1: Create_Themes_Menu (menu: %#lx)\n",menu);
//#endif

#ifdef DEBUG    
    printf("About to malloc script & buf: 55 & 256\n");
#endif
    script=malloc(55);
    buf=malloc(256);
#ifdef DEBUG    
    printf("script,buf: %#lx,%#lx\n",(long) script, (long) buf);
#endif

    if(script==NULL || buf==NULL)
    {
        if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in Create_Themes_Menu.\n", PROGNAME);
            exit(1);
        } else {
// need a nice alert here...
            fprintf(stderr, "%s: Memory allocation failed in Create_Themes_Menu.\n", PROGNAME);
            gQuitFlag=-35;
            return;
        }
    }
    
    sprintf(script,"Contents/Scripts/ThemeList '%s'",randomID);
    printf("%s info: Running: %s\n",PROGNAME,script);
// run script to get list of items...
    system(script);

// This is the file that the script should have just created
    sprintf(script,"/tmp/themelist.%s",randomID);
//#ifdef DEBUG
    printf("%s info: Themelist file: '%s'\n",PROGNAME,script);
//#endif

// Now check to see if the file exists
    if((file=fopen(script, "r"))) 
    {
// Now that we know the file exists, we start fiddling the menu entries
        themeItemsCount=CountMenuItems(menu);
        for(i=itemUserThemes;i<themeItemsCount;i++)
            DeleteMenuItem(menu,itemUserThemes+1);
        themeItemsCount=itemUserThemes;
        
// hack to easily convert the string to a pascal string
        buf++;
        
// now extract the lines from file (max 254 characters)
        while(fgets(buf, 254, file)) 
        {
// only use a line if it does not start with a hash and it is not blank
// (remember that a line includes the newline at the end of it)
            buflen=strlen(buf);
            if(buflen<2) {
                printf("Short line: (%d) %s",buflen,buf);
            } else if(strncmp(buf,"#",1)) {
                printf("%s info: Got an item: %s  ",PROGNAME,buf);
                // now hack it to a pascal string
                buf--;
                buf[0]=buflen;
                AppendMenu(menu,buf);
                buf++;
                themeItemsCount++;
            } else
                printf("Comment: %s",buf); // shouldn't be any of these anyway...?
        } 
// close the file and get rid of it
        fclose(file);
        sprintf(script,"/bin/rm -f /tmp/themelist.%s",randomID);
        printf("%s info: Removing file: %s\n",PROGNAME,script);
        system(script);
        
// make sure that we undo the hack before freeing this...
        buf--;

    } else
        printf("%s warning: themelist file not found: '%s'\n",PROGNAME,script);
    
// and make sure we have the right number of menu items
    themeItemsCount=CountMenuItems(menu);

    if(themeItemsCount<=itemUserThemes) {
        printf("%s: No Themes found!! Could end up fatal...\n",PROGNAME);
        return;
    }
    
#ifdef DEBUG
    printf("About to free buf and script in Create_Themes_Menu...\n");
#endif
    free(buf);
    free(script);
#ifdef DEBUG
    printf("buf and script freed OK\n");
#endif

// search for the current theme, and set it
    if(setThemeDir!=0) {
        printf("%s info: searching for item %s...\n",PROGNAME,gThemeDir);
        setThemeDir=0;
        if(gThemeDir==NULL) {
            printf("%s info: Create_Themes_Menu with NULL theme dir set\n",PROGNAME);
        } else {
            for(i=itemUserThemes;i<themeItemsCount;i++) {
                GetMenuItemText(menu,i+1,itemStr);
                pStr=&itemStr;
                buflen=pStr->len;
                cStr=&(pStr->thestr);
                cStr[buflen]=0;
                printf("%s info: Got item %d: %s\n",PROGNAME,i+1,cStr);
                if(buflen==strlen(gThemeDir))
                    if(!strncmp(cStr,gThemeDir,buflen))
                        setThemeDir=i+1;
            }
        }
        if(setThemeDir==0) {
            if(gThemeDir!=NULL)
                printf("%s warning: Could not find current theme in menu: %s\n",PROGNAME,gThemeDir);
            else {
                printf("%s warning: No theme set; using first in menu...\n",PROGNAME);
                setThemeDir=itemUserThemes+1;
            }
        }
        if(setThemeDir!=0)
            Setup_Themes_Menu(setThemeDir);
    }
    }

/*
 * Rather 'non-Macish' way to get a list of files in the Launch Menu Items folder,
 * and then use it to create the user items for the launch menu
 */
void Create_Launch_Menu()
{
    MenuRef	menu;
    int		i, buflen;
    char	*script=NULL, *buf=NULL;
    FILE	*file;
    
    menu = GetMenuHandle( menuLaunch );

    sprintf(lastsub,"TRACE1: Create_Launch_Menu\n");
    subtrace();
#ifdef SHOW_TRACE1    
    printf("TRACE1: Create_Launch_Menu\n");
#endif

#ifdef DEBUG    
    printf("About to malloc script & buf: 55 & 256\n");
#endif
    script=malloc(55);
    buf=malloc(256);
#ifdef DEBUG    
    printf("script,buf: %#lx,%#lx\n",(long) script, (long) buf);
#endif

    if(script==NULL || buf==NULL)
    {
        if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in Create_Launch_Menu.\n", PROGNAME);
            exit(1);
        } else {
// need a nice alert here...
            fprintf(stderr, "%s: Memory allocation failed in Create_Launch_Menu.\n", PROGNAME);
            gQuitFlag=-35;
            return;
        }
    }
    
    sprintf(script,"Contents/Scripts/LaunchList '%s'",randomID);
    printf("%s info: Running: %s\n",PROGNAME,script);
// run script to get list of items...
    system(script);

// This is the file that the script should have just created
    sprintf(script,"/tmp/launchlist.%s",randomID);
//#ifdef DEBUG
    printf("%s info: Launchlist file: '%s'\n",PROGNAME,script);
//#endif

// Now check to see if the file exists
    if((file=fopen(script, "r"))) 
    {
// Now that we know the file exists, we start fiddling the menu entries
        launchItemsCount=CountMenuItems(menu);
        for(i=itemUserItems;i<launchItemsCount;i++) {
            DeleteMenuItem(menu,itemUserItems+1); }
        launchItemsCount=itemUserItems;
        
// hack to easily convert the string to a pascal string
        buf++;
        
// now extract the lines from file (max 254 characters)
        while(fgets(buf, 254, file)) 
        {
// only use a line if it does not start with a hash and it is not blank
// (remember that a line includes the newline at the end of it)
            buflen=strlen(buf);
            if(buflen<2) {
                printf("Short line: (%d) %s",buflen,buf);
            } else if(strncmp(buf,"#",1)) {
                printf("%s info: Got an item: %s  ",PROGNAME,buf);
                // now hack it to a pascal string
                buf--;
                buf[0]=buflen;
                AppendMenu(menu,buf);
                buf++;
                // just have to reset these counters to zero, I think...
                // Without storing all the item names and checking to see how they have changed
                // it's difficult to keep track of which counters go where if the item list changes...
                launch_counter[launchItemsCount-itemUserItems]=0;
                launchItemsCount++;
            } else
                printf("Comment: %s",buf); // shouldn't be any of these anyway...?
        } 
// close the file and get rid of it
        fclose(file);
        sprintf(script,"/bin/rm -f /tmp/launchlist.%s",randomID);
        printf("%s info: Removing file: %s\n",PROGNAME,script);
        system(script);
        
// make sure that we undo the hack before freeing this...
        buf--;

    } else
        printf("%s warning: launchlist file not found: '%s'\n",PROGNAME,script);
    
#ifdef DEBUG
    printf("About to free buf and script in Create_Launch_Menu...\n");
#endif
    free(buf);
    free(script);
#ifdef DEBUG
    printf("buf and script freed OK\n");
#endif
    
// and make sure we have the right number of menu items
    launchItemsCount=CountMenuItems(menu);
}

void MakeMenu()		/* Put up a menu */
{
    Handle	menuBar;
    MenuRef	menu;
    long	response;
    OSErr	err;
    OSStatus	myStat;
    IBNibRef	theNIBRef;
    
    sprintf(lastsub,"TRACE1: MakeMenu\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: MakeMenu\n");
#endif

    myStat = CreateNibReference(CFSTR("menubar"),&theNIBRef);
    
    myStat = SetMenuBarFromNib(theNIBRef,CFSTR("MainMenu"));
        
    DisposeNibReference(theNIBRef);

    gHiding_Iconbars=1;
    gInterleaving_Windows=0;
    
    iconbarpos=ICONBARPOS_TOPLEFT;
    Setup_Options_Menu(itemTopLeft);
    Setup_Options_Menu(itemMedIconbars);
// can't do the menu items for the screens in Options menu yet since xinerama is not ready -done later
    Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
    Create_Launch_Menu();
    Create_Themes_Menu(0);
    Setup_Themes_Menu(itemUserThemes+1);
}

void Setup_Themes_Menu(int which)
{
    MenuRef	menu;
    int		cnt,i,namelen,kjkasjdhk;
    Str255	itemStr;
    pstr_t	*pStr;
    char	*cStr;
    OSStatus	stat;
    
    sprintf(lastsub,"TRACE3: Setup_Themes_Menu (which: %d)\n",which);
    subtrace();
//#ifdef SHOW_TRACE3
    printf("TRACE3: Setup_Themes_Menu (which: %d)\n",which);
//#endif

//    menu=GetMenuHandle( menuThemes );
    stat = GetMenuItemHierarchicalMenu( GetMenuHandle(menuOptions), itemThemeSubmenu, &menu );
    cnt=CountMenuItems(menu);
    
    if(gUseShapedTheme==0) {
//        printf("Removed mark from item %d (out of %d) on menu %#lx\n",itemToggleShaped,cnt,menu);
        CheckMenuItem(menu, itemToggleShaped, false );
    } else {
//        printf("Put checkmark on item %d (out of %d) on menu %#lx\n",itemToggleShaped,cnt,menu);
        CheckMenuItem(menu, itemToggleShaped, true );
    }
    
    if(which>itemUserThemes) {
        for(i=itemUserThemes+1;i<=cnt;i++)
            CheckMenuItem( menu, i, false );
        SetItemMark( menu, which, diamondMark );
        //printf("Put diamond mark on item: %d (out of %d)\n",which,cnt);
        // now get the name of the item and put it into gThemeDir
        GetMenuItemText(menu,which,itemStr);
        pStr=&itemStr;
        namelen=pStr->len;
        cStr=&(pStr->thestr);
        cStr[namelen]=0;
        if(gThemeDir!=NULL) free(gThemeDir);
        gThemeDir=strdup(cStr);
        printf("%s info: Set new theme directory from menu item: %s\n",PROGNAME,gThemeDir);
        GetMenuItemText(menu,itemAboutThisTheme,itemStr);
        pStr=&itemStr;
        namelen=pStr->len;
        cStr=&(pStr->thestr);
        cStr[namelen]=0;
        if(aboutThemeItem==NULL)
            aboutThemeItem=strdup(cStr);
        sprintf(cStr,"%s %s",aboutThemeItem,gThemeDir);
        namelen=strlen(cStr);
        pStr->len=namelen;
        SetMenuItemText(menu,itemAboutThisTheme,itemStr);
    }
}

void Setup_Options_Menu(int which)
{
    MenuRef	menu;
    int		cnt,i,namelen;
    Str255	itemStr;
    pstr_t	*pStr;
    char	*cStr;

    sprintf(lastsub,"TRACE3: Setup_Options_Menu (which: %d)\n",which);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: Setup_Options_Menu (which: %d)\n",which);
#endif

    menu = GetMenuHandle( menuOptions );
    
    if(gHiding_Iconbars==0)
        CheckMenuItem( menu, itemHideIconbars, false );
    else
        CheckMenuItem( menu, itemHideIconbars, true );
        
    if(gInterleaving_Windows==0)
        CheckMenuItem( menu, itemInterleave, false );
    else
        CheckMenuItem( menu, itemInterleave, true );
    
    if(gMenubarSpace==0)
        CheckMenuItem( menu, itemLeaveMenubar, false );
    else
        CheckMenuItem( menu, itemLeaveMenubar, true );

    if(shrinking_iconbars==0)
        CheckMenuItem( menu, itemFancyIconbars, false );
    else
        CheckMenuItem( menu, itemFancyIconbars, true );
    
    if(which>=itemScreenListStart) {
        cnt=CountMenuItems(menu);
        if(cnt>itemScreenListStart) {
            for(i=itemScreenListStart+1;i<=cnt;i++)
                DeleteMenuItem( menu, itemScreenListStart+1 ); }
        cnt=count_xinerama_heads();
        printf("%s info: Screens for Options menu: %d (%d)\n",PROGNAME,cnt,itemScreenListStart);
        if(cnt>1) {
            GetMenuItemText(menu,itemScreenListStart,itemStr);
// hack (again) to get the string out of the pascal string
// - there's probably a macro to do this 'legally' somewhere!
            pStr=&itemStr;
            namelen=pStr->len;
            cStr=&(pStr->thestr);
            for(i=1;i<cnt;i++) {
// strip off the screen number from the string
                cStr[namelen-1]=0;
                printf("  adding %d\n",i);
                sprintf(cStr,"%s%d",cStr,i);
                pStr->len=strlen(cStr);
                AppendMenu(menu,itemStr);
            }
        }
        cnt+=itemScreenListStart;
        for(i=itemScreenListStart;i<cnt;i++)
            CheckMenuItem( menu, i, false );
        SetItemMark( menu, which, diamondMark );
    } else if(which>=itemTopLeft) {
        CheckMenuItem( menu, itemTopLeft, false );
        CheckMenuItem( menu, itemTopRight, false );
        CheckMenuItem( menu, itemBotLeft, false );
        CheckMenuItem( menu, itemBotRight, false );
        SetItemMark( menu, which, diamondMark );
    } else if(which>=itemSlowIconbars) {
        CheckMenuItem( menu, itemSlowIconbars, false );
        CheckMenuItem( menu, itemMedIconbars, false );
        CheckMenuItem( menu, itemFastIconbars, false );
        SetItemMark( menu, which, diamondMark );
    } 
}

void Compare_Screens(int scrnx, int scrny, int x11x, int x11y, int allowset)
{
    Point	mspt;
    long	nowTicks, notMovedTicks, notCompareTicks;
    int		moving;

// Should never compare when behind, since XDarwin does not track the cursor
    if(gX11InFront==0) return;
    
// once we have a high enough confidence, don't check any more...
//    if(lastchk_cnt>1) return;

    sprintf(lastsub,"TRACE3: Compare_Screens\n");
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: Compare_Screens\n");
#endif

// Work out what we *think* the X11 co-ords should be...
    GetGlobalMouse(&mspt);
    real_x=mspt.h-diffscrn_x;
    real_y=mspt.v-diffscrn_y;
    
// Hmmmm... XDarwin reports funny co-ords once we get inside the menu bar, so ignore
// points near there
    if(mspt.v>-4 && mspt.v<25 && mspt.h>0) return;

    moving=0;
    if(real_x!=scrnx)
        moving=1;
    else if(real_y!=scrny)
        moving=1;
        
//    printf("Mouse co-ords: %d,%d  %d,%d  %d,%d\n",real_x,real_y,scrnx,scrny,x11x,x11y);
//    if(allowset!=0 && gX11MouseStuck!=0) {
//        gX11MouseStuck=0;
//        printf("X11 cursor unstuck with allowset...\n");
//    }
    
    nowTicks=TickCount();
    
    if(moving!=0) {
#ifdef SHOW_MOUSE
        printf("Mouse moved: %d,%d  (from %d,%d)\n",real_x,real_y,lastrl_x,lastrl_y);
#endif
        lastMovedTicks=nowTicks;
        lastrl_x=real_x;
        lastrl_y=real_y;
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
        return;
    }

    if(lastCompareTicks==0) {
        lastCompareTicks=nowTicks;
        return;
    }
    if(lastMovedTicks==0) {
        lastMovedTicks=nowTicks;
        return;
    }
    notMovedTicks=nowTicks-lastMovedTicks;
    notCompareTicks=nowTicks-lastCompareTicks;
    
// leave a gap of at least 2 ticks between each compare
    if(notCompareTicks<2) return;
// make a note of the time when we got here
    lastCompareTicks=nowTicks;

// and only compare if we have definitely been here before, since the cursor stopped moving...
    if(notCompareTicks*2>notMovedTicks) return;
    
// only compare if the cursor has been still for at least sixth of a second...
//    if(notMovedTicks<10) return;
// ...and if it is not in the same place it was at the last check...
//    if(lastchk_x==mspt.h && lastchk_y==mspt.v) return;
// ...and if the x11 pointer does not appear to have frozen
//    if(lastx11_x==x11x && lastx11_y==x11y) return;

    lastrl_x=x11x;
    lastrl_y=x11y;

    lastchk_y=mspt.v;
    lastchk_x=mspt.h;

    if(scrnx!=x11x || scrny!=x11y) {
        // is the x11 cursor stuck?
        if(lastx11_x==x11x && lastx11_y==x11y && allowset<2 && !Button() ) {
#ifdef SHOW_SCREENDIFF
            printf("%s info: X11 cursor stuck?  %d,%d  %d,%d  %d,%d\n",PROGNAME,mspt.h,mspt.v,scrnx,scrny,x11x,x11y);
#endif
            // Always unstick X11 cursor...
            Bring_OOSX_To_Front();
            forceOOSXInFront=FALSE;
            return;
        }
        // make sure we have the last recorded x11 cursor position for future checking
        lastx11_x=x11x;
        lastx11_y=x11y;
        // Are we already confident of the difference, even though it has changed...?
        if(lastchk_cnt>1 && allowset<2) return;
        // start again with the confidence factor
        lastchk_cnt=0;
        // now reset the deltas...
        if(allowset!=0) {
            diffscrn_x += scrnx-x11x;
            diffscrn_y += scrny-x11y;
#ifdef SHOW_SCREENDIFF
            printf("%s info: New screen difference: deltax=%d, deltay=%d   ",PROGNAME,diffscrn_x,diffscrn_y);
            printf("  (reported coords: %d,%d  %d,%d  %d,%d)\n",mspt.h,mspt.v,scrnx,scrny,x11x,x11y);
#endif
        }
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
    } else {
        // don't want to get it wrong if the x11 cursor is stuck
        if(lastx11_x==x11x && lastx11_y==x11y)
            return;
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
        // make sure we have the last recorded x11 cursor position for future checking
        lastx11_x=x11x;
        lastx11_y=x11y;
        // don't go any further if we're already confident enough...
        if(lastchk_cnt>1 && allowset<2) return;
        // now reset the deltas...
        if(allowset!=0) {
            diffscrn_x += scrnx-x11x;
            diffscrn_y += scrny-x11y;
#ifdef SHOW_SCREENDIFF
            printf("%s info: Screen compare confidence: %d    deltax=%d, deltay=%d\n",PROGNAME,lastchk_cnt,diffscrn_x,diffscrn_y);
#endif
            // got the same as at the last check, so increment the confidence factor
            lastchk_cnt++;
        }
    }
}

void Setup_Window_Menu(int has_frame, int has_close, int has_min, int has_zoom, int is_float, int can_af, int can_ar)
{
    MenuRef	menu, propmenu;
    OSStatus	stat;
    long	nextwin;
    Str255	itemStr;
    pstr_t	*pStr;
    char	*cStr;
    int		namelen;
    
    sprintf(lastsub,"TRACE3: Setup_Window_Menu (has_frame,can_af,can_ar: %d,%d,%d)\n",has_frame,can_af,can_ar);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: Setup_Window_Menu (has_frame,can_af,can_ar: %d,%d,%d)\n",has_frame,can_af,can_ar);
#endif

    menu = GetMenuHandle( menuWindow );
    stat = GetMenuItemHierarchicalMenu( menu, itemProperties, &propmenu );

    if(has_frame==0) {
        EnableMenuItem(menu,0);
        DisableMenuItem(menu,itemWindowshade);
        DisableMenuItem(menu,itemMinimise);
        DisableMenuItem(menu,itemZoom);
        DisableMenuItem(menu,itemClose);
        DisableMenuItem(menu,itemLower);
        DisableMenuItem(menu,itemNext);
        cycleOff=1;
        DisableMenuItem(menu,itemProperties);
        DisableMenuItem(propmenu,0);
        CheckMenuItem(propmenu,itemAutoFocus,false);
        CheckMenuItem(propmenu,itemAutoRaise,false);
        CheckMenuItem(propmenu,itemPopup,false);
        CheckMenuItem(propmenu,itemNoframes,false);
//        DisableMenuItem(menu,0);
        DrawMenuBar();
        return;
    }
    
    EnableMenuItem(menu,0);

    EnableMenuItem(menu,itemWindowshade);
    EnableMenuItem(menu,itemMinimise);
    EnableMenuItem(menu,itemZoom);
    EnableMenuItem(menu,itemClose);
    EnableMenuItem(menu,itemLower);
    
        GetMenuItemText(menu,itemNext,itemStr);
        pStr=&itemStr;
        namelen=pStr->len;
        cStr=&(pStr->thestr);
        cStr[namelen]=0;
        if(nextItem==NULL)
            printf("%s info: Starting out nextItem as %s\n",PROGNAME,cStr);
        if(nextItem==NULL)
            nextItem=strdup(cStr);
        nextwin=get_next_osxwinref(0);
        if(nextwin==0) {
            sprintf(cStr,"%s",nextItem);
            DisableMenuItem(menu,itemNext);
            DisableMenuItem(menu,itemLower);
            cycleOff=1;
        } else {
            cycleOff=0;
            GetWTitle((WindowRef) nextwin,itemStr);
            pStr=&itemStr;
            namelen=pStr->len;
            cStr=&(pStr->thestr);
            cStr[namelen]=0;
            cStr=strdup(pStr->thestr);
            sprintf(pStr->thestr,"%s:  \"%s\"",nextItem,cStr);
            free(cStr);
            cStr=&(pStr->thestr);
            EnableMenuItem(menu,itemNext);
        }
#ifdef DEBUG
        printf("Setting next item to %s\n",cStr);
#endif
        namelen=strlen(cStr);
        pStr->len=namelen;
        SetMenuItemText(menu,itemNext,itemStr);
        
    EnableMenuItem(menu,itemProperties);

    if(has_close==0)
        DisableMenuItem(menu,itemClose);
    
    if(has_min==0)
        DisableMenuItem(menu,itemMinimise);

    if(has_zoom==0)
        DisableMenuItem(menu,itemZoom);

    EnableMenuItem(propmenu,0);

    EnableMenuItem(propmenu,itemFloat);
    EnableMenuItem(propmenu,itemAutoFocus);
    EnableMenuItem(propmenu,itemAutoRaise);

    if(is_float==0)
        DisableMenuItem(propmenu,itemFloat);
    else if(is_float==1)
        CheckMenuItem(propmenu,itemFloat,true);
    else if(is_float==-1)
        CheckMenuItem(propmenu,itemFloat,false);
        
    if(can_ar==0) {
        CheckMenuItem(propmenu,itemAutoRaise,false);
        DisableMenuItem(propmenu,itemAutoRaise);
    } else if(can_ar==1)
        CheckMenuItem(propmenu,itemAutoRaise,true);
    else if(can_ar==-1)
        CheckMenuItem(propmenu,itemAutoRaise,false);

    if(can_af==0) {
        CheckMenuItem(propmenu,itemAutoFocus,false);
        DisableMenuItem(propmenu,itemAutoFocus);
        DisableMenuItem(propmenu,itemAutoRaise);
    } else if(can_af==1)
        CheckMenuItem(propmenu,itemAutoFocus,true);
    else if(can_af==-1) {
        CheckMenuItem(propmenu,itemAutoFocus,false);
        DisableMenuItem(propmenu,itemAutoRaise);
    }
    
    DrawMenuBar();
}

void DoIdle(int trackMouse)
{
    int			moving;
    short		myErr;
    Point		mspt;
    ProcessSerialNumber	frontPSN;
    Boolean		x11InFront;
    Boolean		same, cursorInMenubar=FALSE;
    WindowRef		currentFrontWin;

#ifdef DEBUG
    ProcessInfoRec	procInfo;
    pstr_t		myName;
    pstr_t		procName;
#endif

    sprintf(lastsub,"TRACE1: DoIdle (gX11InFront,trackMouse: %d,%d)\n",gX11InFront,trackMouse);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: DoIdle (gX11InFront,trackMouse: %d,%d)\n",gX11InFront,trackMouse);
#endif

    myErr=GetFrontProcess(&frontPSN);
    if(myErr!=noErr)
        return;
        
    myErr = GetCurrentProcess(&myPSN);
    if(myErr!=noErr)
        return;
        
#ifdef DEBUG
    procInfo.processAppSpec=NULL;
    procInfo.processName=(char *) &myName;
    myErr=GetProcessInformation(&myPSN,&procInfo);
    if(myErr!=noErr)
        return;
    myName.thestr[(int) myName.len]=0;

    procInfo.processAppSpec=NULL;
    procInfo.processName=(char *) &procName;
    myErr=GetProcessInformation(&frontPSN,&procInfo);
    if(myErr!=noErr)
        return;
    procName.thestr[(int) procName.len]=0;
#endif

    myErr=SameProcess(&xPSN,&frontPSN,&x11InFront);
    if(myErr!=noErr)
        return;

    if(x11InFront)
        xPSN=frontPSN;
        
    myErr=SameProcess(&myPSN,&frontPSN,&same);
    if(myErr!=noErr)
        return;

    GetGlobalMouse(&mspt);
    cursorInMenubar=FALSE;
    
    if(x11InFront || same)
        if(mspt.h>=gMainRect.left && mspt.v>=gMainRect.top && mspt.v<gMainRect.top+22 && mspt.h<=gMainRect.right) {
            cursorInMenubar=TRUE;
            left_client();
        }

// Fix for extra items on far right of menubar in OSX10.1 -only works for holding down button,
// not for click-release in menubar item...
    if(cursorInMenubar) {
        if( Button() )
// gives an extra 30 ticks after button release before allowing switch to XDarwin
            gGotMenuClick=TickCount()+30;
        else
            gGotMenuClick=0;
    } else if (gGotMenuClick!=0) {
        if( Button() ) {
// gives an extra 30 ticks after button release before allowing switch to XDarwin
            gGotMenuClick=TickCount()+30;
            cursorInMenubar=TRUE;
        } else if(gGotMenuClick>TickCount()) {
            cursorInMenubar=TRUE;
        } else
            gGotMenuClick=0;
    }
    
    currentFrontWin=FrontWindow();

    if( IsWindowVisible(currentFrontWin) ) {
        if(gInvisible!=0) {
            printf("%s info: Front window is visible again\n",PROGNAME);
            gInvisible=0;
            map_all_clients();
        }
    } else {
        if(gInvisible==0) {
            printf("%s info: Front window is invisible\n",PROGNAME);
            gInvisible=1;
            unmap_all_clients();
        }
    }
            
    if(x11InFront) {
#ifdef SHOW_FRONT
        printf("FRONT: XDarwin\n");
#endif
// Make sure OroborOSX application is in front if the about window is frontmost...
        if(currentFrontWin==aboutWin || currentFrontWin==passwordWin) {
            Bring_OOSX_To_Front();
            same=TRUE;
            x11InFront=FALSE;
            forceOOSXInFront=FALSE;
// Also needs to be frontmost if the cursor is in the menubar - but we still want to
// act as if XDarwin is in front (i.e. keep the current X11 focus window)
        } else if(cursorInMenubar) {
            Bring_OOSX_To_Front();
            forceOOSXInFront=FALSE;
        } else if(forceOOSXInFront) {
            Bring_OOSX_To_Front();
            forceOOSXInFront=FALSE;
        }
    } else if(same) {
#ifdef SHOW_FRONT
        printf("FRONT: %s\n",PROGNAME);
#endif
// But if the OroborOSX application is in front, and the about window is not frontmost...
        if(currentFrontWin!=aboutWin && currentFrontWin!=passwordWin) {
// ...then we must make sure the right window has the focus (before XDarwin comes in front)
            if(currentFrontWin!=lastFrontWin) {
                MoveWindow(currentFrontWin,-5000,-5000,false);
#ifdef SHOW_EVENTS
                printf("New window in front: %#lx %#lx\n",currentFrontWin,lastFrontWin);
#endif
// tell the window manager that a new X11 window has come in front
		Restart_XDarwin();
                change_focus((long) currentFrontWin);
		Stop_XDarwin();
                lastFrontWin=currentFrontWin;
            }
// ...and then we want XDarwin in front
// (unless the cursor is in the menubar, in which case we pretend it is)
            if(!cursorInMenubar) {
		Restart_XDarwin();
                Bring_X_To_Front(0);
            	Stop_XDarwin();
            } else if(forceOOSXInFront)
                forceOOSXInFront=FALSE;
            same=FALSE;
            x11InFront=TRUE;
        }
#ifdef SHOW_FRONT
    } else {
        printf("FRONT: unknown\n");
#endif
    }

// Check to see if the frontmost window has changed
    if(currentFrontWin!=lastFrontWin) {
        if(currentFrontWin==aboutWin || currentFrontWin==passwordWin) {
// Disable the window menu if the about window is frontmost
            Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
        } else {
// And now make sure the frontmost window is off the screen
            MoveWindow(currentFrontWin,-5000,-5000,false);
#ifdef SHOW_EVENTS
            printf("New window in front: %#lx %#lx\n",currentFrontWin,lastFrontWin);
#endif
            if(x11InFront) {
// tell the window manager that a new X11 window has come in front
                Restart_XDarwin();
                change_focus((long) currentFrontWin);
                Stop_XDarwin();
            }
        }
        lastFrontWin=currentFrontWin;
    }
        
    real_x=mspt.h-diffscrn_x;
    real_y=mspt.v-diffscrn_y;
    
    moving=0;
    if(real_x>lastrl_x+3)
        moving=2;
    else if(real_y>lastrl_y+3)
        moving=2;
    else if(real_x<lastrl_x-3)
        moving=2;
    else if(real_y<lastrl_y-3)
        moving=2;
    else if(real_x!=lastrl_x)
        moving=1;
    else if(real_y!=lastrl_y)
        moving=1;
        
    if(moving!=0) {
#ifdef SHOW_MOUSE
        printf("Mouse moved: %d,%d  (from %d,%d)\n",real_x,real_y,lastrl_x,lastrl_y);
#endif
        lastMovedTicks=TickCount();
        lastMovedTen=lastMovedTicks;
        lastrl_x=real_x;
        lastrl_y=real_y;
    } else if(TickCount()>lastMovedTen+10) {
        lastMovedTen=TickCount();
        moving=10;
    }

    if(x11InFront) {
    
	if(gX11InFront==0) {
#ifdef DEBUG
            printf("%s has come to front\n",procName.thestr);
#endif
            gX11InFront=1;
            Restart_XDarwin();
            come_to_front();
            Stop_XDarwin();
        }

//        printf("Calling do_event_loop with 2000 or 1000...\n");
        if( moving==0 )
            do_event_loop(2000,0);
        else
            do_event_loop(1000,moving);

    } else {
    
        if(gX11InFront!=0) {
#ifdef DEBUG
            if(same)
                printf("%s: I am in front!\n",procName.thestr);
            else
                printf("%s has come to front\n",procName.thestr);
#endif
            gX11InFront=0;
            Restart_XDarwin();
            gone_to_back();
            Stop_XDarwin();
        }
        
//        printf("Calling do_event_loop with 4000 or 2000...\n");
        if( moving==0 )
            do_event_loop(4000,0);
        else
            do_event_loop(2000,moving);
    }
    
    if(gQuitFlag==0)
        if(lastIconbarOutTicks!=0)
            if(TickCount()>lastIconbarOutTicks+iconbar_WaitTicks) {
                Restart_XDarwin();
                hide_all_iconbars();
            	Stop_XDarwin();
            }
}

void DoEvent(EventRecord *event)
{
    short		part;
    Boolean		hit;
    char		key;
    Rect		tempRect;
    WindowRef		whichWindow;
    long		menusel;
    Point		mouse;
    ControlHandle	control;
        
    sprintf(lastsub,"TRACE1: DoEvent (type: %d)\n",event->what);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: DoEvent (type: %d)\n",event->what);
#endif

    switch (event->what) 
    {
        case mouseDown:
#ifdef SHOW_EVENTS
            printf("Got mouse down...");
#endif
            part = FindWindow(event->where, &whichWindow);
            switch (part)
            {
                case inMenuBar:  /* process a moused menu command */
                    system("/usr/bin/touch /var/tmp/oroborosx.menus");
                    menusel=MenuSelect(event->where);
                    system("/bin/rm -rf /var/tmp/oroborosx.menus");
#ifdef SHOW_EVENTS
                    printf(" in menubar (%#lx)...\n",menusel);
#endif
                    if(menusel!=0)
                        DoMenuCommand(menusel,0,0);
                    break;
                    
                case inSysWindow:
                    break;
                
                case inContent:
#ifdef SHOW_EVENTS
                    printf(" in window (%#lx)...\n",whichWindow);
#endif
                    if(whichWindow != FrontWindow()) 
                        SelectWindow(whichWindow);
                    if(whichWindow==passwordWin) {
                        SetPort(GetWindowPort(whichWindow));
                        mouse = event->where;    //get the mouse location
                        GlobalToLocal(&mouse);   //convert to local coordinates
                        part = FindControl(mouse, whichWindow, &control);
                        printf("   ...got control part: %d\n",part);
                    }
                    break;
                
                case inDrag:	/* pass screenBits.bounds */
#ifdef SHOW_EVENTS
                    printf(" in window title (%#lx)...\n",whichWindow);
#endif
                    Restart_XDarwin();
                    if(showingAboutWin)
                        if(whichWindow==aboutWin)
                            if(gX11InFront==1) {
                                gX11InFront=0;
                                gone_to_back();
                                }
                    GetRegionBounds(GetGrayRgn(), &tempRect);
                    DragWindow(whichWindow, event->where, &tempRect);
                    Stop_XDarwin();
                    break;
                    
                case inGrow:
                    printf(" in window resize widget (%#lx)...\n",whichWindow);
                    break;
                    
                case inGoAway:
#ifdef SHOW_EVENTS
                    printf(" in window close widget (%#lx)...\n",whichWindow);
#endif
                    Restart_XDarwin();
                    hit = TrackBox(whichWindow, event->where, part);
                    Stop_XDarwin();
                    if (hit) 
                    {
                        if(whichWindow==aboutWin) {
#ifdef DEBUG
                            printf("Hiding about window\n");
#endif
                            showingAboutWin=0;
                            DisposeWindow(aboutWin);
                            aboutWin=NULL;
                            if(showingNoFocusWin!=0) {
                                ShowWindow(noFocusWin);
                                SelectWindow(noFocusWin);
                            }
                        } else {
#ifdef DEBUG
                            printf("Closing window: %#lx (%#lx)\n",whichWindow,aboutWin);
#endif
                            DisposeWindow(whichWindow); }
/*                        quit();
                        system("/bin/sleep 1");
                        ExitToShell();*/
                    }
                    break;
                    
                case inZoomIn:
                case inZoomOut:
                    printf(" in window zoom widget (%#lx)...\n",whichWindow);
                    Restart_XDarwin();
                    hit = TrackBox(whichWindow, event->where, part);
                    Stop_XDarwin();
                    if (hit) 
                    {
                        SetPort(GetWindowPort(whichWindow));   // window must be current port
                        EraseRect(GetWindowPortBounds(whichWindow, &tempRect));   // inval/erase because of ZoomWindow bug
                        ZoomWindow(whichWindow, part, true);
                        InvalWindowRect(whichWindow, GetWindowPortBounds(whichWindow, &tempRect));	
                    }
                    break;
            }
            break;
		
            case keyDown:
            case autoKey:
                key = event->message & charCodeMask;
                if((event->modifiers & cmdKey)==0) {
//                    if(passwordWin!=NULL && key==65) {
//                        printf("Got rid of password window\n");
//                        DisposeWindow(passwordWin);
//                        passwordWin=NULL;
//                    }
                } else if (event->what == keyDown) {
                    // deal with the shift-key menu items
                    // ANNOYING!!! - why won't this work automatically?!?
                    if((event->modifiers & shiftKey)!=0) {
#ifdef SHOW_EVENTS
                        printf("Got shift-command-key %d\n",key);
#endif
                        if(key==47)		// "OroborOSX Help" in Help menu
                            DoMenuCommand((long) 0,menuHelp,itemHelp);
                        else if(key==102)	// "Auto-focus" in Window menu
                            DoMenuCommand((long) 0,menuProperties,itemAutoFocus);
                        else if(key==114)	// "Auto-raise" in Window menu
                            DoMenuCommand((long) 0,menuProperties,itemAutoRaise);
                        else if(cycleOff==0) {
                            if(key==96)		// "Next" in Window menu -as shift backquote
                                DoMenuCommand((long) 0,menuWindow,itemNext);
                            else if(key==126)	// "Next" in Window menu again -as tilde, +shift held down
                                DoMenuCommand((long) 0,menuWindow,itemNext);
                        }
                    } else {
#ifdef SHOW_EVENTS
                        printf("Got command-key: %d\n",key);
#endif
                        if(key==96) key=126; // "Send To Back" in Window menu
                        DoMenuCommand(MenuKey(key),0,0);
                    }
                }
            case activateEvt:	       /* if you needed to do something special */
                break;
                    
            case updateEvt:
                    DrawWindow((WindowRef) event->message);
                    break;
                        
            case kHighLevelEvent:
#ifdef SHOW_EVENTS
                    printf("Got an AppleEvent...\n");
#endif
                    AEProcessAppleEvent( event );
                    break;
		
            case diskEvt:
                    break;
                
            default:
#ifdef SHOW_EVENTS
                    printf("TRACE1: Got an unknown event: %d\n",event->what);
#endif
                    break;
    }
        
    sprintf(lastsub,"TRACE1: leaving DoEvent\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: leaving DoEvent\n");
#endif
}

void RunX11App(char *name, int namelen, char *args, int arglen)
{
    char *script=NULL;

    sprintf(lastsub,"TRACE1: RunX11App (name,args: %s %s)\n",name,args);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: RunX11App (name,args: %s %s)\n",name,args);
#endif

#ifdef DEBUG
    printf("About to malloc script in RunX11App: %d\n",namelen);
#endif
    script=malloc(namelen+arglen+strlen(Display_Name)+50);
#ifdef DEBUG
    printf("script: %#lx\n",(long) script);
#endif

    if(script==NULL)
    {
	if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in RunX11App.\n", PROGNAME);
            return;
        } else {
            fprintf(stderr, "%s: Memory allocation failed in RunX11App.\n", PROGNAME);
            return;
        }
    }
    
    if (arglen==0)
        sprintf(script,"Contents/LaunchScripts/generic '%s' '%s'", Display_Name, name);
    else
        sprintf(script,"Contents/LaunchScripts/generic '%s' '%s' %s", Display_Name, name, args);

//#ifdef DEBUG
    printf("%s info: Running: %s\n",PROGNAME,script);
//#endif

// run script to launch X11 application...
    system(script);

#ifdef DEBUG
    printf("About to free script in RunX11App...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void RunX11Script(int item)
{
    MenuRef	menu;
    Str255	itemStr;
    int		namelen, cntr;
    pstr_t	*pStr;
    char	*cStr;
    char	*script=NULL;

    sprintf(lastsub,"TRACE1: RunX11Script (item: %d)\n",item);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: RunX11Script (item: %d)\n",item);
#endif

    menu = GetMenuHandle( menuLaunch );
    GetMenuItemText(menu,item,itemStr);
    
// hack to get the string out of the pascal string
// - there's probably a macro to do this 'legally' somewhere!
    pStr=&itemStr;
    namelen=pStr->len;
    cStr=&(pStr->thestr);
    cStr[namelen]=0;
    
#ifdef DEBUG
    printf("Got item: (%d) %s\n",namelen,cStr);    
    printf("About to malloc script in RunX11Script: %d\n",namelen);
#endif
    script=malloc(namelen+strlen(Display_Name)+65);
#ifdef DEBUG
    printf("script: %#lx\n",(long) script);
#endif
    if(script==NULL)
    {
	if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in RunX11Script.\n", PROGNAME);
            return;
        } else {
            fprintf(stderr, "%s: Memory allocation failed in RunX11Script.\n", PROGNAME);
            return;
        }
    }
    
    // counters start at zero... (oops! never mind)
    cntr=launch_counter[item-itemUserItems-1]+1;
    // Tell the LaunchList script to launch the item
    if(cntr==1)
        sprintf(script,"Contents/Scripts/LaunchList launch '%s.x11app' '%s'",cStr,Display_Name);
    else
        sprintf(script,"Contents/Scripts/LaunchList launch '%s.x11app' '%s' '%d'",cStr,Display_Name,cntr);
    launch_counter[item-itemUserItems-1]=cntr;

//#ifdef DEBUG
    printf("%s info: Running: %s\n",PROGNAME,script);
//#endif
    system(script);
    
#ifdef DEBUG
    printf("About to free script in RunX11Script...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void Edit_Startup_Items()
{
    char *script=NULL;

    sprintf(lastsub,"TRACE1: Edit_Startup_Items\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Edit_Startup_Items\n");
#endif

#ifdef DEBUG
    printf("About to malloc script in Edit_Startup_Items: %s\n",Display_Name);
#endif
    script=malloc(45+strlen(Display_Name));
#ifdef DEBUG
    printf("script: %#lx\n",(long) script);
#endif
    if(script==NULL)
    {
	if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in Edit_Startup_Items.\n", PROGNAME);
            return;
        } else {
            fprintf(stderr, "%s: Memory allocation failed in Edit_Startup_Items.\n", PROGNAME);
            return;
        }
    }

// crude editing method - just open up the file in xedit for the user to fiddle with...
    sprintf(script,"Contents/Scripts/EditStartups '%s'",Display_Name);
    printf("%s info: Running: %s\n",PROGNAME,script);
    system(script);

#ifdef DEBUG
    printf("About to free script in Edit_Startup_Items...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void Launch_Startup_Items()
{
    char *script=NULL;
    char buf[255];
    FILE *file;
    int buflen;

    sprintf(lastsub,"TRACE1: Launch_Startup_Items\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Launch_Startup_Items\n");
#endif

#ifdef DEBUG
    printf("About to malloc script in Launch_Startup_Items: 60\n");
#endif
    script=malloc(60);
#ifdef DEBUG
    printf("script: %#lx\n",(long) script);
#endif
    if(script==NULL)
    {
	if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in Launch_Startup_Items.\n", PROGNAME);
            return;
        } else {
            fprintf(stderr, "%s: Memory allocation failed in Launch_Startup_Items.\n", PROGNAME);
            return;
        }
    }

// Tell the EditStartups script to make a temporary copy of the StartupItems file
// (This lets the script do the work of finding out if it's the user's personal one)
    sprintf(script,"Contents/Scripts/EditStartups 'copy' '%s'",randomID);
    printf("%s info: Running: %s\n",PROGNAME,script);
    system(script);

// This is the name of the temporary file
    sprintf(script,"/tmp/StartupItems.%s",randomID);
#ifdef DEBUG
    printf("Temporary StartupItems file: %s\n",script);
#endif
    
// Check to see if the file exists
    if((file=fopen(script, "r"))) 
    {        
// and extract each line from the file (max 254 characters for a line)
        while(fgets(buf, 254, file)) 
        {
// only use a line if it does not start with a hash and it is not blank
// (remember that a line includes the newline at the end of it)
            buflen=strlen(buf);
            if(buflen<2) {
#ifdef DEBUG
                printf("Short line: (%d)  %s",buflen,buf);
#endif
            } else if(strncmp(buf,"#",1)) {
// Now try to launch it (must be the same as an item in the Launch menu)
                printf("%s info: Got an item: (%d)  %s",PROGNAME,buflen,buf);
                LaunchMenuItem(buf,0,1);
#ifdef DEBUG
            } else {
                printf("Comment: %s",buf);
#endif
            }
        } 
// close the file
        fclose(file);
// and remove it
        sprintf(script,"/bin/rm -rf /tmp/StartupItems.%s",randomID);
//#ifdef DEBUG
        printf("%s info: removing temporary file: %s\n",PROGNAME,script);
//#endif
        system(script);
    } else
        printf("%s warning: temporary StartupItems file not found: '%s'\n",PROGNAME,script);
    
#ifdef DEBUG
    printf("About to free script in Launch_Startup_Items...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void Edit_Menu_Items(char *scriptname)
{
    char *script=NULL;

    sprintf(lastsub,"TRACE1: Edit_Menu_Items: %s\n",scriptname);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Edit_Menu_Items: %s\n",scriptname);
#endif

#ifdef DEBUG
    printf("About to malloc script in Edit_Menu_Items: 45\n");
#endif
    script=malloc(25+strlen(scriptname));
#ifdef DEBUG
    printf("script: %#lx\n",(long) script);
#endif
    if(script==NULL)
    {
	if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in Edit_Menu_Items.\n", PROGNAME);
            return;
        } else {
            fprintf(stderr, "%s: Memory allocation failed in Edit_Menu_Items.\n", PROGNAME);
            return;
        }
    }

// crude editing method - the LaunchList/ThemeList script just opens up the Launch Menu Items
// folder for the user to fiddle with...
    sprintf(script,"Contents/Scripts/%s open",scriptname);
    printf("%s info: Running: %s\n",PROGNAME,script);
    system(script);
    
#ifdef DEBUG
    printf("About to free script in Edit_Menu_Items...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif

// Once OroborOSX is brought in front, it will recheck the Launch Menu Items folder
// and continue to do so every ten seconds for about a minute - hopefully this will
// allow it to catch any changes that are made to the items in the folder...
// switched off -use "Rebuild Launch Menu" item in the Launch menu...
// or the "Rebuild Themes Menu" item in the Themes menu...
//    reReadOnNextFront=-6;
    lastOKTicks=TickCount();
}

void LaunchItem(int item)
{
    char argstr[128];
    int arglen=0;
    
    sprintf(lastsub,"TRACE2: LaunchItem (item: %d)\n",item);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: LaunchItem (item: %d)\n",item);
#endif

    sprintf(argstr,"");
    
    switch (item)
    {
        case itemEditStart:
            Edit_Startup_Items();
            break;
            
        case itemNewItem:
            printf("How did you do that!! -not yet available.\n");
            break;
            
        case itemEditItems:
            Edit_Menu_Items("LaunchList");
            break;
            
        case itemRebuildMenu:
            Create_Launch_Menu();
            break;
            
        case itemxinitrc:
            RunX11App("xinitrc",7,"",0);
            break;
            
// These have all been replaced by x11app items in the Launch Menu Items folder...
/*
        case itemxterm:
            if(launch_count_xterm==1)
                sprintf(argstr,"-ls -sb -sl 5000 -name \"`/bin/hostname`\"");
            else
                sprintf(argstr,"-ls -sb -sl -name \"`/bin/hostname` (%d)\"",launch_count_xterm);
            arglen=strlen(argstr);
            RunX11App("xterm",5,argstr,arglen);
            launch_count_xterm++;
            break;
        
        case itemxedit:
            if(launch_count_xedit==1)
                sprintf(argstr,"-name \"xedit\"");
            else
                sprintf(argstr,"-name \"xedit (%d)\"",launch_count_xedit);
            arglen=strlen(argstr);
            RunX11App("xedit",5,argstr,arglen);
            launch_count_xedit++;
            break;
        
        case itemxbiff:
            if(launch_count_xbiff==1)
                sprintf(argstr,"-geometry 50x50-0+0 -file /var/mail/`/usr/bin/whoami` -title \"mail:`/usr/bin/whomai`\"");
            else
                sprintf(argstr,"-geometry 50x50-0+0 -file /var/mail/`/usr/bin/whoami` -title \"mail:`/usr/bin/whomai` (%d)\"",launch_count_xbiff);
            arglen=strlen(argstr);
            RunX11App("xbiff",5,argstr,arglen);
            launch_count_xbiff++;
            break;
        
        case itemxclock:
            if(launch_count_xclock==1)
                sprintf(argstr,"-geometry 70x70-0-0 -title \"xclock\"");
            else
                sprintf(argstr,"-geometry 70x70-0-0 -title \"xclock (%d)\"",launch_count_xclock);
            arglen=strlen(argstr);
            RunX11App("xclock",6,argstr,arglen);
            launch_count_xclock++;
            break;
        
        case itemxeyes:
            if(launch_count_xeyes==1)
                sprintf(argstr,"-geometry 100x60-50+0 +shape -fg black -bg skyblue -outline black -center white -title \"xeyes\"");
            else
                sprintf(argstr,"-geometry 100x60-50+0 +shape -fg black -bg skyblue -outline black -center white -title \"xeyes (%d)\"",launch_count_xeyes);
            arglen=strlen(argstr);
            RunX11App("xeyes",5,argstr,arglen);
            launch_count_xeyes++;
            break;
        
        case itemxcalc:
            if(launch_count_xcalc==1)
                sprintf(argstr,"-title \"Calculator\"");
            else
                sprintf(argstr,"-title \"Calculator (%d)\"",launch_count_xcalc);
            arglen=strlen(argstr);
            RunX11App("xcalc",5,argstr,arglen);
            launch_count_xcalc++;
            break;
*/            
        default:
            if(item>itemUserItems)
                RunX11Script(item);
            else
                printf("What menu item was that? %d\n",item);
            break;
    }        
}

/*
 * Launch an item from the Launch menu given its name
 */
 
int LaunchMenuItem(char *itemname, int hasext, int hasnl)
{
    MenuRef	menu;
    Str255	itemStr;
    int		namelen, item, itemlen;
    pstr_t	*pStr;
    char	*cStr;

    itemlen=strlen(itemname);
    
    sprintf(lastsub,"TRACE2: LaunchMenuItem (itemname,itemlen,hasext: %s , %d,%d)\n",itemname,itemlen,hasext);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: LaunchMenuItem (itemname,itemlen,hasext: %s , %d,%d)\n",itemname,itemlen,hasext);
#endif

// Strip off the .x11app extension, if necessary
    if(hasext!=0) {
        if(itemlen<8) return -2;
        itemlen-=7; }
        
// And strip off the newline, if necessary
    if(hasnl!=0) {
        if(itemlen<2) return -2;
        itemlen-=1; }
    
    menu = GetMenuHandle( menuLaunch );

// Loop through the items in the Launch menu, looking for a match
    for(item=itemxinitrc;item<=launchItemsCount;item++) {
        GetMenuItemText(menu,item,itemStr);
    
// use that nasty hack again, to get the string out of the pascal string
// - there's probably a macro to do this 'legally' somewhere!
        pStr=&itemStr;
        namelen=pStr->len;
        cStr=&(pStr->thestr);
        cStr[namelen]=0;
                
// Now compare the strings, and if they match Launch that item
        if(namelen==itemlen)
            if(!strncmp(cStr,itemname,itemlen)) {
                LaunchItem(item);
                return 0; }
    }
    
// failed to find item
    return -1;
}

void Change_Theme(int toggleShape, int themeNum)
{
    if(themeNum==0)
        gUseShapedTheme=toggleShape;
    Setup_Themes_Menu(themeNum);
    reload_config();
}

void DoPasswordWindow()
{
    OSStatus	myStat;
    EventRef	outEvent;
    EventTargetRef theTarget;
    long	startPWTicks;

    theTarget = GetEventDispatcherTarget();
    myStat=noErr;
    startPWTicks=TickCount();
    while(myStat==noErr) {
        DoIdle(1);
        myStat=ReceiveNextEvent(0,NULL,kEventDurationForever,TRUE,&outEvent);
        if(myStat==noErr) {
            printf("Got event... %d\n",TickCount()-startPWTicks);
            SendEventToEventTarget(outEvent, theTarget);
            ReleaseEvent(outEvent);
        }
        if(TickCount()>startPWTicks+3600) myStat=1;
    }
    printf("Removing password window...\n");
    sleep(3);
    DisposeWindow(passwordWin);
    passwordWin=NULL;
}

void DoMenuCommand(long menuResult, short menuID, short menuItem)
{
//    short	menuID;		/* the resource ID of the selected menu */
//    short	menuItem;	/* the item number of the selected menu */
    
    sprintf(lastsub,"TRACE1: DoMenuCommand (menuResult: %#lx)\n",menuResult);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: DoMenuCommand (menuResult: %#lx)\n",menuResult);
#endif

    if(menuID==0 || menuItem==0) {
        if(menuResult==0) return;
        menuID = HiWord(menuResult);    /* use macros to get item & menu number */
        menuItem = LoWord(menuResult);
    }
    
#ifdef SHOW_EVENTS
    printf("Got menuID, menuItem: %d, %d (%#lx)\n",menuID,menuItem,menuResult);
#endif
    switch (menuID) 
    {
        case menuApplication:
            switch (menuItem) 
            {
                case itemAbout:
                    DoAboutBox();
                    break;
                    
/*                case itemQuit:
                    quit();
                    system("/bin/sleep 1");
                    ExitToShell();
                    break;
*/				
                default:
                    break;
            }
            break;
        
        case menuLaunch:
            LaunchItem(menuItem);
            break;
            
        case menuWindow:
            Restart_XDarwin();
            manipulate_focus_client(menuItem);
            Stop_XDarwin();
            break;
            
        case menuProperties:
            Restart_XDarwin();
            manipulate_focus_client(menuItem+100);
            Stop_XDarwin();
            break;
		
        case menuEdit:
            break;

        case menuOptions:
            if(menuItem==itemInterleave) {
                passwordWin=MakeWindow(passwordWintype);
                if(passwordWin==NULL)
                    printf("Failed to show password window!\n");
                else
                    DoPasswordWindow();
            } else {
                Restart_XDarwin();
                change_options(menuItem);
                Stop_XDarwin();
            }
            break;

        case menuHelp:
            if(menuItem==itemHelp)
                ShowOroborOSXHelp();
            break;

        case menuThemes:
            switch (menuItem)
            {
                case itemAddTheme:
                    break;
                    
                case itemEditThemeList:
                    Edit_Menu_Items("ThemeList");
                    break;
                    
                case itemRebuildThemes:
                    Create_Themes_Menu(1);
                    break;
                    
                case itemToggleShaped:
                    Change_Theme(1-gUseShapedTheme,0);
                    break;
                    
                default:
                    if(menuItem>itemUserThemes)
                        Change_Theme(gUseShapedTheme,menuItem);
                    else
                        printf("How on earth did you get that Themes menu item?! %d\n",menuItem);
                    break;
            }
            break;
    }
    HiliteMenu(0);	// unhighlight what MenuSelect (or MenuKey) hilited
    Restart_XDarwin();
    force_ungrab();	// Try to force ungrabbing of cursor (sometimes gets grabbed on menu select)
    Stop_XDarwin();
}

void DrawWindow(WindowRef window)
{
    Rect		tempRect;
    GrafPtr		curPort;
	
    sprintf(lastsub,"TRACE3: DrawWindow (window: %#lx)\n",window);
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: DrawWindow (window: %#lx)\n",window);
#endif

    GetPort(&curPort);
    if(window!=aboutWin && window!=passwordWin)
        MoveWindow(window,-5000,-5000,false);
    SetPort(GetWindowPort(window));
    BeginUpdate(window);
    EraseRect(GetWindowPortBounds(window, &tempRect));
    DrawControls(window);
    DrawGrowIcon(window);
    EndUpdate(window);
    SetPort(curPort);
}

void DoAboutBox(void)
{
    sprintf(lastsub,"TRACE3: DoAboutBox\n");
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: DoAboutBox\n");
#endif

//   (void) Alert(kAboutBox, nil);  / simple alert dialog box
    aboutWin=(WindowRef) MakeWindow(aboutWintype);
    if(aboutWin==NULL) return;
    
    gX11InFront=0;
    Setup_Window_Menu(0, 0, 0, 0, 0, 0, 0);
    gone_to_back();

    if(lastFrontWin==noFocusWin) {
        HideWindow(noFocusWin);
        showingNoFocusWin=1;
    }
        
    ShowWindow(aboutWin);
    SelectWindow(aboutWin);
#ifdef DEBUG
    printf("Showing about window: %#lx\n",aboutWin);
#endif
    showingAboutWin=1;
    lastFrontWin=aboutWin;
}

void ShowOroborOSXHelp(void)
{
// Just use the About box for now...
    DoAboutBox();
}

/*
 * For debugging purposes...
 */
void subtrace()
{
    free(lastsub15);
    lastsub15=lastsub14;
    lastsub14=lastsub13;
    lastsub13=lastsub12;
    lastsub12=lastsub11;
    lastsub11=lastsub10;
    lastsub10=lastsub9;
    lastsub9=lastsub8;
    lastsub8=lastsub7;
    lastsub7=lastsub6;
    lastsub6=lastsub5;
    lastsub5=lastsub4;
    lastsub4=lastsub3;
    lastsub3=lastsub2;
    lastsub2=lastsub1;
    lastsub1=strdup(lastsub);
}

void show_last_ten()
{
    printf("%s info: Last ten routines:\n",PROGNAME);
    printf("  %s",lastsub10);
    printf("  %s",lastsub9);
    printf("  %s",lastsub8);
    printf("  %s",lastsub7);
    printf("  %s",lastsub6);
    printf("  %s",lastsub5);
    printf("  %s",lastsub4);
    printf("  %s",lastsub3);
    printf("  %s",lastsub2);
    printf("  %s",lastsub1);
    list_clients_and_windows();
}

void show_last_fifteen()
{
    printf("%s info: Last fifteen routines:\n",PROGNAME);
    printf("  %s",lastsub15);
    printf("  %s",lastsub14);
    printf("  %s",lastsub13);
    printf("  %s",lastsub12);
    printf("  %s",lastsub11);
    printf("  %s",lastsub10);
    printf("  %s",lastsub9);
    printf("  %s",lastsub8);
    printf("  %s",lastsub7);
    printf("  %s",lastsub6);
    printf("  %s",lastsub5);
    printf("  %s",lastsub4);
    printf("  %s",lastsub3);
    printf("  %s",lastsub2);
    printf("  %s",lastsub1);
    list_clients_and_windows();
}


